"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueueBuffer = void 0;
var QueueBuffer = /** @class */ (function () {
    function QueueBuffer(buf) {
        this._end = 0;
        this.buffer = buf;
    }
    QueueBuffer.prototype.push = function (buf) {
        this.buffer.set(buf, this._end);
        this._end += buf.length;
    };
    QueueBuffer.prototype.pop = function (size) {
        var bytesToCopy = size > this._end ? this._end : size;
        var buf = Buffer.allocUnsafe(bytesToCopy);
        this.buffer.copy(buf, 0, 0, bytesToCopy);
        this.buffer.set(this.buffer.slice(bytesToCopy), 0);
        this._end -= bytesToCopy;
        return buf;
    };
    return QueueBuffer;
}());
exports.QueueBuffer = QueueBuffer;
//# sourceMappingURL=QueueBuffer.js.map