"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseIpcHeader = exports.parseSegmentHeader = exports.parseFrameHeader = exports.isMagical = void 0;
var BufferReader_1 = require("./BufferReader");
function isMagical(header) {
    return header.magic1.toString() === "16304822851840528978" && header.magic2.toString() === "8486076352731294335";
}
exports.isMagical = isMagical;
function parseFrameHeader(buf) {
    var br = new BufferReader_1.BufferReader(buf);
    return {
        magic1: br.nextUInt64(),
        magic2: br.nextUInt64(),
        timestamp: br.nextUInt64(),
        size: br.nextUInt32(),
        connectionType: br.nextUInt16(),
        segmentCount: br.nextUInt16(),
        unknown20: br.nextUInt8(),
        isCompressed: Boolean(br.nextUInt8()),
        unknown24: br.nextUInt32(),
    };
}
exports.parseFrameHeader = parseFrameHeader;
function parseSegmentHeader(buf) {
    var br = new BufferReader_1.BufferReader(buf);
    return {
        size: br.nextUInt32(),
        sourceActor: br.nextUInt32(),
        targetActor: br.nextUInt32(),
        segmentType: br.nextUInt16(),
    };
}
exports.parseSegmentHeader = parseSegmentHeader;
function parseIpcHeader(buf) {
    var br = new BufferReader_1.BufferReader(buf);
    return {
        reserved: br.nextUInt16(),
        type: br.nextUInt16(),
        padding: br.nextUInt16(),
        serverId: br.nextUInt16(),
        timestamp: br.nextUInt32(),
        padding1: br.nextUInt32(),
    };
}
exports.parseIpcHeader = parseIpcHeader;
//# sourceMappingURL=frame-processing.js.map