"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadPacketProcessors = void 0;
var actorControl_1 = require("./processors/actorControl");
var currencyCrystalInfo_1 = require("./processors/currencyCrystalInfo");
var effectResult_1 = require("./processors/effectResult");
var eventPlay_1 = require("./processors/eventPlay");
var eventPlay4_1 = require("./processors/eventPlay4");
var eventPlay32_1 = require("./processors/eventPlay32");
var initZone_1 = require("./processors/initZone");
var inventoryTransaction_1 = require("./processors/inventoryTransaction");
var itemInfo_1 = require("./processors/itemInfo");
var marketBoardItemListingCount_1 = require("./processors/marketBoardItemListingCount");
var marketBoardItemListingHistory_1 = require("./processors/marketBoardItemListingHistory");
var marketBoardSearchResult_1 = require("./processors/marketBoardSearchResult");
var marketTaxRates_1 = require("./processors/marketTaxRates");
var playerSetup_1 = require("./processors/playerSetup");
var playerStats_1 = require("./processors/playerStats");
var prepareZoning_1 = require("./processors/prepareZoning");
var retainerInformation_1 = require("./processors/retainerInformation");
var updateClassInfo_1 = require("./processors/updateClassInfo");
var updateInventorySlot_1 = require("./processors/updateInventorySlot");
var actorCast_1 = require("./processors/actorCast");
var actorControlSelf_1 = require("./processors/actorControlSelf");
var actorControlTarget_1 = require("./processors/actorControlTarget");
var actorFreeSpawn_1 = require("./processors/actorFreeSpawn");
var actorOwner_1 = require("./processors/actorOwner");
var actorMove_1 = require("./processors/actorMove");
var actorGauge_1 = require("./processors/actorGauge");
var actorSetPos_1 = require("./processors/actorSetPos");
var blackList_1 = require("./processors/blackList");
var cFAvailableContents_1 = require("./processors/cFAvailableContents");
var cFDutyInfo_1 = require("./processors/cFDutyInfo");
var cFRegisterDuty_1 = require("./processors/cFRegisterDuty");
var cFPlayerInNeed_1 = require("./processors/cFPlayerInNeed");
var clientTrigger_1 = require("./processors/clientTrigger");
var charaVisualEffect_1 = require("./processors/charaVisualEffect");
var desynthResult_1 = require("./processors/desynthResult");
var eorzeaTimeOffset_1 = require("./processors/eorzeaTimeOffset");
var equipDisplayFlags_1 = require("./processors/equipDisplayFlags");
var eventPlay8_1 = require("./processors/eventPlay8");
var freeCompanyUpdateShortMessage_1 = require("./processors/freeCompanyUpdateShortMessage");
var inventoryModifyHandler_1 = require("./processors/inventoryModifyHandler");
var logMessage_1 = require("./processors/logMessage");
var mount_1 = require("./processors/mount");
var npcSpawn_1 = require("./processors/npcSpawn");
var objectSpawn_1 = require("./processors/objectSpawn");
var persistentEffect_1 = require("./processors/persistentEffect");
var playerSpawn_1 = require("./processors/playerSpawn");
var playTime_1 = require("./processors/playTime");
var reductionResult_1 = require("./processors/reductionResult");
var serverNotice_1 = require("./processors/serverNotice");
var someDirectorUnk4_1 = require("./processors/someDirectorUnk4");
var statusEffectList_1 = require("./processors/statusEffectList");
var updateHpMpTp_1 = require("./processors/updateHpMpTp");
var updatePositionHandler_1 = require("./processors/updatePositionHandler");
var updatePositionInstance_1 = require("./processors/updatePositionInstance");
var useMooch_1 = require("./processors/useMooch");
var weatherChange_1 = require("./processors/weatherChange");
function loadPacketProcessors() {
    return {
        actorCast: actorCast_1.actorCast,
        actorControl: actorControl_1.actorControl,
        actorControlSelf: actorControlSelf_1.actorControlSelf,
        actorControlTarget: actorControlTarget_1.actorControlTarget,
        actorFreeSpawn: actorFreeSpawn_1.actorFreeSpawn,
        actorGauge: actorGauge_1.actorGauge,
        actorMove: actorMove_1.actorMove,
        actorOwner: actorOwner_1.actorOwner,
        actorSetPos: actorSetPos_1.actorSetPos,
        blackList: blackList_1.blackList,
        cFAvailableContents: cFAvailableContents_1.cFAvailableContents,
        cFDutyInfo: cFDutyInfo_1.cFDutyInfo,
        cFPlayerInNeed: cFPlayerInNeed_1.cFPlayerInNeed,
        cFRegisterDuty: cFRegisterDuty_1.cFRegisterDuty,
        charaVisualEffect: charaVisualEffect_1.charaVisualEffect,
        clientTrigger: clientTrigger_1.clientTrigger,
        currencyCrystalInfo: currencyCrystalInfo_1.currencyCrystalInfo,
        desynthResult: desynthResult_1.desynthResult,
        effectResult: effectResult_1.effectResult,
        eorzeaTimeOffset: eorzeaTimeOffset_1.eorzeaTimeOffset,
        equipDisplayFlags: equipDisplayFlags_1.equipDisplayFlags,
        eventPlay: eventPlay_1.eventPlay,
        eventPlay4: eventPlay4_1.eventPlay4,
        eventPlay8: eventPlay8_1.eventPlay8,
        eventPlay32: eventPlay32_1.eventPlay32,
        freeCompanyUpdateShortMessage: freeCompanyUpdateShortMessage_1.freeCompanyUpdateShortMessage,
        initZone: initZone_1.initZone,
        inventoryModifyHandler: inventoryModifyHandler_1.inventoryModifyHandler,
        inventoryTransaction: inventoryTransaction_1.inventoryTransaction,
        itemInfo: itemInfo_1.itemInfo,
        logMessage: logMessage_1.logMessage,
        marketBoardItemListingCount: marketBoardItemListingCount_1.marketBoardItemListingCount,
        marketBoardItemListingHistory: marketBoardItemListingHistory_1.marketBoardItemListingHistory,
        marketBoardSearchResult: marketBoardSearchResult_1.marketBoardSearchResult,
        marketTaxRates: marketTaxRates_1.marketTaxRates,
        mount: mount_1.mount,
        npcSpawn: npcSpawn_1.npcSpawn,
        objectSpawn: objectSpawn_1.objectSpawn,
        persistentEffect: persistentEffect_1.persistentEffect,
        playerSetup: playerSetup_1.playerSetup,
        playerSpawn: playerSpawn_1.playerSpawn,
        playerStats: playerStats_1.playerStats,
        playTime: playTime_1.playTime,
        prepareZoning: prepareZoning_1.prepareZoning,
        reductionResult: reductionResult_1.reductionResult,
        retainerInformation: retainerInformation_1.retainerInformation,
        serverNotice: serverNotice_1.serverNotice,
        someDirectorUnk4: someDirectorUnk4_1.someDirectorUnk4,
        statusEffectList: statusEffectList_1.statusEffectList,
        updateClassInfo: updateClassInfo_1.updateClassInfo,
        updateHpMpTp: updateHpMpTp_1.updateHpMpTp,
        updateInventorySlot: updateInventorySlot_1.updateInventorySlot,
        updatePositionHandler: updatePositionHandler_1.updatePositionHandler,
        updatePositionInstance: updatePositionInstance_1.updatePositionInstance,
        useMooch: useMooch_1.useMooch,
        weatherChange: weatherChange_1.weatherChange,
    };
}
exports.loadPacketProcessors = loadPacketProcessors;
//# sourceMappingURL=load-packet-processors.js.map